/***********************/
/*    Gtk-Mimee 1.0    */
/* Programme Principal */
/***********************/

#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <gtk/gtk.h>
#include <glade/glade.h>
#include <libintl.h>

#define _(x) gettext(x)
#include "Geodesie.c"
#include "iobrial.h"
#include "initialisation.h"

//--------------------------
#include <malloc.h>
int mem0=0;
//--------------------------

/*********************/
/*Lancement du Calcul*/
/*********************/

void go()
{
	//--------------------------
	struct mallinfo tas;
	//--------------------------
	
	struct coord crd0;
	guint8 Zn;
	guint8 decimales,fix3,fix8;
	GtkWidget* MsgBox;

	MsgBox = gtk_message_dialog_new (NULL,0,GTK_MESSAGE_WARNING,GTK_BUTTONS_CLOSE,"Projection Inconnue");

	if (!flag1) return;

        /*** Choix du nombre de decimales de l'affichage ***/
        fix3=gtk_combo_box_get_active (GTK_COMBO_BOX(FIX));
        if (fix3==0)
           {
           fix3=3;
           fix8=8;
           }
        else
           {
           fix3--;
           fix8=fix3;
           }
        decimales=fix3;
        /***************************************************/

	crd0.x=inputd(X1);
	crd0.y=inputd(Y1);
	crd0.z=inputd(Z1);

        if (indg1>3)
           {
           if (strcmp(type_grille1,"TM")==0) //if input coordinates are Transverse Mercator
                {
                struct grille grid0 = grid1;
                if (indg1==4) //if input coordinates are UTM
                   {
                   grid0.Lon0=LongitudeOrigineUTM(inputd(ZUTM1));
                   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(Sud))) grid0.N0 = 10000000;
                   }
                crd0 = InvProjectionTM(ellips1,grid0,crd0);
                }

           else if (strcmp(type_grille1,"CO")==0) crd0=InvProjectionConique(ellips1,grid1,crd0);
           else if (strcmp(type_grille1,"OM")==0) crd0=InvProjectionObliqueMercator(ellips1,grid1,crd0);
           else if (strcmp(type_grille1,"ST")==0) crd0=InvProjectionStereographique(ellips1,grid1,crd0);
           else if (strcmp(type_grille1,"GR")==0)
                {
                crd0.x=crd0.x*0.9*radian+grid1.Lon0;
                crd0.y*=0.9*radian;
                }

           else
                {
                gtk_dialog_run(GTK_DIALOG(MsgBox));gtk_widget_destroy (MsgBox);
                return;
                }
           }

        if (indg1<3) //if input coordinates are geographical
                     {
              	     switch (indg1)
              	            {
                            case 1: //degree and decimal minutes (D.MMmmm)
              	                 crd0.x=dmm2deg(crd0.x);
                                 crd0.y=dmm2deg(crd0.y);
                                 break;
                            case 2: //degree-minute-seconde (D.MMSSsss)
              	                 crd0.x=deg(crd0.x);
                                 crd0.y=deg(crd0.y);
                                 break;
                            }
                     crd0.x*=radian;
                     crd0.y*=radian;
                     }

        if (indd1!=indd2)
           {
           if (indg1!=3) crd0=geocentric(ellips1,crd0); //if input coordinates are not Geocentric
           crd0=datumshift(datum1,datum2,crd0);
           }

        if ((indd1!=indd2)||(indg1==3))
           {
           if (indg2!=3) crd0=geographic(ellips2,crd0);
           }
        else if (indg2==3)
                {
                crd0 = geocentric(ellips1,crd0);
                }

        if (indg2<3)
                     {
                     decimales=fix8;
              	     switch (indg2)
              	            {
              	            case 0:
              	                 crd0.x/=radian;
                                 crd0.y/=radian;
                                 break;
                            case 1:
              	                 crd0.x=deg2dmm(crd0.x/radian);
                                 crd0.y=deg2dmm(crd0.y/radian);
                                 break;
                            case 2:
                                 crd0.x=dms(crd0.x/radian);
                                 crd0.y=dms(crd0.y/radian);
                                 break;
                            }
                     }

        if (indg2>3)
           {
           if (strcmp(type_grille2,"TM")==0)
                {
                struct grille grid0 = grid2;
                if (indg2==4)
                   {
                   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (UTMlock))) Zn=inputd(ZUTM2);
                   else
                       {
                       Zn = ZoneUTM(crd0.x);
                       printi(ZUTM2,Zn);
                       }
                   if (crd0.y < 0)
                      {
                      grid0.N0 = 10000000;
                      gtk_entry_set_text(GTK_ENTRY(Hemisphere),"S");
                      }
                   else gtk_entry_set_text(GTK_ENTRY(Hemisphere),"N");
                   grid0.Lon0 = LongitudeOrigineUTM(Zn);
                   if (!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (UTMlock)))
                      {
                      if ((crd0.x > -0.1047197551196) && (crd0.x<0)) grid0.Lon0 = -0.05235987755983;
                      if ((crd0.x < 0.1047197551196) && (crd0.x>=0)) grid0.Lon0 = 0.05235987755983;
                      }
                   }
                crd0=ProjectionTM(ellips2,grid0,crd0);
                }


           else if (strcmp(type_grille2,"CO")==0) crd0=ProjectionConique(ellips2,grid2,crd0);
           else if (strcmp(type_grille2,"OM")==0) crd0=ProjectionObliqueMercator(ellips2,grid2,crd0);
           else if (strcmp(type_grille2,"ST")==0) crd0=ProjectionStereographique(ellips2,grid2,crd0);
           else if (strcmp(type_grille2,"GR")==0)
                {
                decimales=fix8;
                crd0.x=(crd0.x-grid2.Lon0)/radian/0.9;
                crd0.y=crd0.y/radian/0.9;
                }


           else
                {
                gtk_dialog_run(GTK_DIALOG(MsgBox));gtk_widget_destroy (MsgBox);
                return;
                }
           }


	printdx(X2,crd0.x,decimales);
    printdx(Y2,crd0.y,decimales);
	printdx(Z2,crd0.z,fix3);
	//--------------------------
	tas=mallinfo();
	printf("chunks : %d\t%d\n",tas.fordblks,tas.fordblks-mem0);
	mem0=tas.fordblks;
	//--------------------------
}

void on_liste_changed()
	{
	if (flag1)
		{
		indg1=gtk_combo_box_get_active (GTK_COMBO_BOX(Grille1));
		indg2=gtk_combo_box_get_active (GTK_COMBO_BOX(Grille2));
		indd1=gtk_combo_box_get_active (GTK_COMBO_BOX(Datum1));
		indd2=gtk_combo_box_get_active (GTK_COMBO_BOX(Datum2));
		ChargementDonnees();
		DisplayUTMfields();
		gtk_widget_grab_focus(X1);
		}
    }

/***************************/
/*                         */
/*         BOUTONS         */
/*                         */
/***************************/

/*Chargement des favoris*/
/************************/

void LoadFav()
	{
	FILE *fav;
	char *chemin=catalloc(racine,".favorites");
	fav=fopen(chemin,"r");
	if (fav)
		{
		fscanf(fav,"%d %d %d %d",&indg1,&indg2,&indd1,&indd2);
		RefreshPopupLists();
    	DisplayUTMfields();
    	fclose(fav);
    	}
    free(chemin);
    }


void SaveFav()
	{
	FILE *fav;
	char *chemin=catalloc(racine,".favorites");
	fav=fopen(chemin,"w");
	if (fav)
		{
		fprintf(fav,"%d %d %d %d\n",indg1,indg2,indd1,indd2);
		fclose(fav);
		}
	}

void on_ListTop_clicked()
	{
	indg1=0;
    indg2=0;
    indd1=0;
    indd2=0;
    RefreshPopupLists();
    DisplayUTMfields();
    }

void on_CopyToLeft_clicked()
    {
    guint8 indProvisoire;
    if (input(X2)!=NULL && *input(X2)!='[') gtk_entry_set_text(GTK_ENTRY(X1),input(X2));
    else gtk_entry_set_text(GTK_ENTRY(X1),"");
    if (input(Y2)!=NULL && *input(Y2)!='[') gtk_entry_set_text(GTK_ENTRY(Y1),input(Y2));
    else gtk_entry_set_text(GTK_ENTRY(Y1),"");
    if (input(Z2)!=NULL && *input(Z2)!='[') gtk_entry_set_text(GTK_ENTRY(Z1),input(Z2));
    else gtk_entry_set_text(GTK_ENTRY(Z1),"");
    if (input(ZUTM2)!=NULL) gtk_entry_set_text(GTK_ENTRY(ZUTM1),input(ZUTM2));
    if (input(Hemisphere)!=NULL)
	{
	if (strcmp(input(Hemisphere),"S")==0) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Sud),TRUE);
	else gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(Nord),TRUE);
	}
    indProvisoire=indg1;
    indg1=indg2;
    indg2=indProvisoire;
    indProvisoire=indd1;
    indd1=indd2;
    indd2=indProvisoire;
    RefreshPopupLists();
    DisplayUTMfields();
    if (gtk_widget_get_visible (ZUTM2))
    	{
    	gtk_entry_set_text(GTK_ENTRY(ZUTM2),"");
    	gtk_entry_set_text(GTK_ENTRY(Hemisphere),"");
    	}
    gtk_combo_box_set_active(GTK_COMBO_BOX(FIX),0);
    gtk_widget_grab_focus(X1);
    }


void on_Cls_clicked()
	{
	gtk_entry_set_text(GTK_ENTRY(X1),"");
	gtk_entry_set_text(GTK_ENTRY(Y1),"");
	gtk_entry_set_text(GTK_ENTRY(Z1),"");
	gtk_entry_set_text(GTK_ENTRY(X2),"");
	gtk_entry_set_text(GTK_ENTRY(Y2),"");
	gtk_entry_set_text(GTK_ENTRY(Z2),"");
	gtk_entry_set_text(GTK_ENTRY(ZUTM1),"");
	gtk_entry_set_text(GTK_ENTRY(ZUTM2),"");
	gtk_entry_set_text(GTK_ENTRY(Hemisphere),"");
	gtk_widget_grab_focus(X1);
	}

gboolean on_window1_key_press_event(GtkWidget   *widget, GdkEventKey *event, gpointer user_data)
	{
	if (event->keyval == 65421 || event->keyval == 65293) gtk_widget_child_focus(GTK_WIDGET(fixed1),GTK_DIR_TAB_FORWARD);
	return FALSE;
	}

void quit()
	{
	printf(_("Saving session\n"));
	fprintf(logfile,"Saving session\n");
	SaveSession();
	printf(_("Exiting GTK\n"));
	fprintf(logfile,"Exiting GTK\n");
	gtk_main_quit();
	printf(_("Interface closed\nProgram terminated.\n"));
	fprintf(logfile,"Interface closed\nProgram terminated.\n");
	}

int main (int argc, char *argv[])
	{
	//gboolean b;
	char *chemin;
	int l;	// Longueur Racine
	GladeXML *gladexml;
	GList *liste=NULL;
	
	printf("argv[0] = --%s--\n",argv[0]);
		
	l=strlen(argv[0])-strlen(strrchr(argv[0],'/')+1);
	racine=calloc(l+1,1);
	memcpy(racine,argv[0],l);
	printf("racine = --%s--\n",racine);
	
	chemin=catalloc(racine,"mimee.glade");
	printf("chemin = --%s--\n",chemin);
	
	gtk_disable_setlocale ();
	gtk_init (&argc, &argv);
	gladexml = glade_xml_new(chemin, NULL, NULL);
	free(chemin);
  	glade_xml_signal_autoconnect(gladexml);

	    window1 = glade_xml_get_widget(gladexml, "window1");
	    fixed1 = glade_xml_get_widget(gladexml, "fixed1");
	    X1 = glade_xml_get_widget(gladexml, "X1");
	    Y1 = glade_xml_get_widget(gladexml, "Y1");
	    Z1 = glade_xml_get_widget(gladexml, "Z1");
	    X2 = glade_xml_get_widget(gladexml, "X2");
	    Y2 = glade_xml_get_widget(gladexml, "Y2");
	    Z2 = glade_xml_get_widget(gladexml, "Z2");
	    ZUTM1 = glade_xml_get_widget(gladexml, "ZUTM1");
	    ZUTM2 = glade_xml_get_widget(gladexml, "ZUTM2");
	    ZNUTM = glade_xml_get_widget(gladexml, "ZNUTM");
	    Grille1 = glade_xml_get_widget(gladexml, "Grille1");
	    Grille2 = glade_xml_get_widget(gladexml, "Grille2");
	    Datum1 = glade_xml_get_widget(gladexml, "Datum1");
	    Datum2 = glade_xml_get_widget(gladexml, "Datum2");
	    FIX = glade_xml_get_widget(gladexml, "FIX");
	    UTMlock = glade_xml_get_widget(gladexml, "UTMlock");
	    Nord = glade_xml_get_widget(gladexml, "Nord");
	    Sud = glade_xml_get_widget(gladexml, "Sud");
	    Hemisphere = glade_xml_get_widget(gladexml, "Hemisphere");
	    Ok = glade_xml_get_widget(gladexml, "Ok");

	//gtk_widget_show (window1);
	gtk_widget_grab_focus(X1);
	gtk_combo_box_set_active(GTK_COMBO_BOX(Grille1),0);
	gtk_combo_box_set_active(GTK_COMBO_BOX(Grille2),0);
	gtk_combo_box_set_active(GTK_COMBO_BOX(Datum1),0);
	gtk_combo_box_set_active(GTK_COMBO_BOX(Datum2),0);
	gtk_combo_box_set_active(GTK_COMBO_BOX(FIX),0);
	flag1=TRUE;
	on_liste_changed();
	liste=g_list_append(NULL,X1);
	liste=g_list_append(liste,Y1);
	liste=g_list_append(liste,Z1);
	liste=g_list_append(liste,Ok);
	gtk_container_set_focus_chain (GTK_CONTAINER(fixed1),liste);
	StartLogFile();
	if (initdata()) LoadSession();
	else fprintf(logfile,"Missing databases\n");
	fprintf (logfile,"Launching graphic interface now...\n");
	gtk_main ();
	fclose(logfile);
	return 0;
	}
